;******************************************************************************
;    Filename: Interrupt.Asm                                                   *
;    Date:                                                                    *
;    File Version: 000.001                                                    *
;    Author: PSW.RU                                                           *
;    Company: Labs                                                            *
;******************************************************************************
	#include Define.inc	;     
	global	LowInt
	;Extern	InitAll,HighInt
;******************************************************************************
;	global	HighInt;
HiInt	code	0x0008
;    
	btfsc	INTCON,TMR0IF,ACCESS; 0 -    1-Wire  
		bra	IntTimer0
;	btfsc	PIR3,TMR5IF,ACCESS;    -  2 
;		bra	IntTimer5
;IntTimer5:
 	bcf		PIR3,TMR5IF,ACCESS;   	
	#ifdef	PCPWM_Present
 incf	Timer5_Upper,F,ACCESS;    24 
	#endif
;	nop
; bsf T5CON,TMR5ON,ACCESS ;  Timer
 retfie	FAST;
;  0x18  0x08  8  
;  c 5, 3  .
;    1      32   
;     
	bra	0x0	; 
	bra	0x0	; 
	bra	0x0	; 
LowInt	code	0x0018	;
	bra	IntAdc
IntTimer0:
	bcf		INTCON,TMR0IF,ACCESS;   0
;	bcf		T0CON,TMR0ON,ACCESS	;  
 #ifdef	Timer0_Present
 		#include Proj_Dir\1W\Int_1W.inc	;   .
 #endif
		retfie FAST	;; 

; Low priority interrupt vector and routine
; This code will start executing when a low priority interrupt occurs.
; This code can be removed if low priority interrupts are not used.
LowInt: ; - ,   
IntAdc: ;    ,     PCPWM
	bcf	PIR1,ADIF,ACCESS	; ADC Flag Clear  
;      MainLoop -     
;      1       
; 18 750 	
		movff	WREG,WREG_TEMP		;save working register
		movff	STATUS,STATUS_TEMP	;save STATUS register
		movff	BSR,BSR_TEMP		;save BSR register

;		movff	FSR0L,FSR0L_Temp	;  
;		movff	FSR0H,FSR0H_Temp	;  
		movff	TBLPTRL,TBLPTRL_Temp	;
		movff	TBLPTRH,TBLPTRH_Temp	;
;		movff	TBLPTRU,TBLPTRU_Temp	;  
;		movff	EECON1,EECON1_Temp	;    
		movff	TABLAT,TABLAT_Temp		;			
		movff	PRODH,PRODH_Temp		;
		movff	PRODL,PRODL_Temp		;

AdcIntNest	;        
;  1    /    18 750 .
;  2     ""  12 ,   16 .

 #ifdef	ADC_Present
 	#ifdef	PCPWM_Present
			extern DelayCuriosity	;
	#include Proj_Dir\PCPWM_3F\Int_PCPWM_3F_4431.inc ;      .	
 	#endif
 #ifndef __DEBUG_;*******  
	#include Proj_Dir\ADC\Int_ADC.inc	;     .
 #endif
 	#ifdef	RTK_ADC_Source
  		#include Proj_Dir\RTK\Int_RTK_Tmr.inc	;   -   
	#endif
 #ifdef	PCPWM_Present
	dcfsnz	PCPWM_AccelCounter,F,ACCESS;      /
		bsf PCPWM_Flag,5,ACCESS	;;5=     9 375  ,   
 #endif
 	#ifdef	PCPWM_Present
 Extern	PCPWM_Task

 #ifndef __DEBUG_;*******  
	call	PCPWM_Task ;  ,   .
 #endif

	#endif

 #endif

;	bsf	PCPWM_Flag,0,ACCESS	;  PCPWM   
;      

	btfss	PIR1,ADIF,ACCESS	; ADC
		bra	ExitLoInt
	bcf	PIR1,ADIF,ACCESS	; ADC Flag Clear
	#ifdef	PCPWM_Present
 		incf	PCPWM_Err,F,ACCESS	;   
	#endif

	bra	AdcIntNest	;
;;		rcall	IntAdc
ExitLoInt
;		movff	FSR0L_Temp,FSR0L	;variable used for context saving
;		movff	FSR0H_Temp,FSR0H	;variable used for context saving
		movff	TBLPTRL_Temp,TBLPTRL	;
		movff	TBLPTRH_Temp,TBLPTRH	;
;		movff	TBLPTRU_Temp,TBLPTRU	;
;		movff	EECON1_Temp,EECON1	;    
		movff	TABLAT_Temp,TABLAT		;			
		movff	PRODH_Temp,PRODH		;
		movff	PRODL_Temp,PRODL		;

		movff	BSR_TEMP,BSR		;restore BSR register
		movff	WREG_TEMP,WREG		;restore working register
		movff	STATUS_TEMP,STATUS	;restore STATUS register
		retfie
;
; #ifdef	Timer1_Present
;	btfss	PIR1,TMR1IF,ACCESS	; 1-10    DC 
;		bra	NextInt1
;	btfsc	PIE1,TMR1IE,ACCESS		;   ?
;		rcall	IntTmr1
; #endif
;NextInt1
;
; #ifdef	IntPortB_Present
;	btfss	INTCON,RBIF,ACCESS	;  -    1 10   	
;		bra	NextInt2
;	btfsc	INTCON,RBIE,ACCESS	;;   ?
;		rcall	IntPortB
; #endif
;NextInt2
;
; #ifdef	Timer5_Present
;	btfss	PIR3,TMR5IF,ACCESS	;  TMR5  ?
;		bra		NextInt3			;
;	btfsc	PIE3,TMR5IE,ACCESS		;   ?
;		rcall	IntTmr5	;bra		Int_Timer2			;
; #endif
;NextInt3
;
;; #ifdef	ADC_Present
;;	btfss	PIR1,ADIF,ACCESS	; ADC
;;		bra	NextInt4
;;	btfsc	PIE1,ADIE,ACCESS			;   ?
;;		rcall	IntAdc
;; #endif
;;NextInt4
;;
;; #ifdef	PCPWM_Present
;;	btfss	PIR3,PTIF,ACCESS	; PCPWM
;;		bra	NextInt5
;;	btfsc	PIE3,PTIE,ACCESS			;   ?
;;		rcall	IntPWM
;; #endif
;;NextInt5
;;
;; #ifdef	Timer0_Present
;;	btfss	INTCON,TMR0IF,ACCESS ; 0 -    1-Wire  
;;		bra	NextInt0
;;	btfsc	INTCON,TMR0IE,ACCESS		;   ?
;;		rcall	IntTmr0
;; #endif
;;NextInt0
;;
;
;IntPWM	;    
;	bcf	PIR3,PTIF,ACCESS	; PWM Flag Clear
; #ifdef	PCPWM_Present
;;FAST	#include Proj_Dir\PCPWM_3F\Int_PCPWM_3F_4431.inc	
;;    .
; #endif
;		return
;
;IntAdc	;    
;	bcf	PIR1,ADIF,ACCESS	; ADC Flag Clear
; #ifdef	ADC_Present
;	#ifdef	RTK_ADC_Source
;;FAST  		#include Proj_Dir\RTK\Int_RTK_Tmr.inc	;   -   
;	#endif
;;FAST	#include Proj_Dir\ADC\Int_ADC.inc	;     .
; #endif
;		return
;IntTmr0
;	bcf		INTCON,TMR0IF,ACCESS		;;   0
;;	bcf		T0CON,TMR0ON,ACCESS		;  
; #ifdef	Timer0_Present
;; FAST 		#include Proj_Dir\1W\Int_1W.inc	;   .
; #endif
;		return
;IntTmr1	; -1 -    1 .  
;	bcf	PIR1,TMR1IF,ACCESS	; Timer1 Flag Clear
;	#ifndef	RTK_ADC_Source
;  		#include Proj_Dir\RTK\Int_RTK_Tmr.inc	;     -1
;	#endif
;	return
;IntTmr5:
;	bcf		PIR3,TMR5IF,ACCESS	;   
; #ifdef	Timer5_Present
; 		#include Proj_Dir\Int_Tmr5.inc	;   .
; #endif
;	return
;IntPortB	;  -    1 10   
;	movf	PORTB,W,0		;    
;	bcf		INTCON,RBIF,0	;  
; #ifdef	IntPortB_Present
;	andlw	b'11100000'		;   
;	movwf	PortB_Buf,0		;      	
;	bsf		TaskFlag1,1,ACCESS		;  PortB    PortB 
;	#include Proj_Dir\Int_Encoder.inc>	; Encod   .
; #endif
;	return

;HighInt	code	 0x100	;            
;addwf	PCL,F,0	; -- PCL.  U  H     
;   1  2       
;   -  /  .


;     -   , 11.7  23.4  
IntPWM	;    
;	btfss	PIR3,PTIF,ACCESS	; PWM Flag Clear
;		bra		HiNextInt1
	bcf	PIR3,PTIF,ACCESS	; PWM Flag Clear
		retfie ;FAST	; 



;;End of program
		END
