;**********************************************************************************************
;16/08 Bit Unsigned Fixed Point Divide 16/08 -> 16.08
;Input:  16 bit unsigned fixed point dividend in AARGB0, AARGB1
;         8 bit unsigned fixed point divisor in BARGB0
;Output: 16 bit unsigned fixed point quotient in AARGB0, AARGB1
;         8 bit unsigned fixed point remainder in REMB0
;Result: AARG, REM  <--  AARG / BARG

;Testing from 100000 trials:
;		min	max	mean
;	Timing:	--------------	clks
   

;FXD1608U
;	GLOBAL		FXD1608U

 	;

;FXD1608U1

;FXD1608U2
 ;	GLOBAL		FXD1608U2

 MOVFF A_Arg+0,Reminder+1	;
 MOVFF A_Arg+1,Reminder+0	;

 MOVF TABLAT,W,ACCESS		; estimate quotient
 MULWF Reminder+1,BANKED	;
 MOVFF PRODH,A_Arg+0		;
 MOVFF PRODL,A_Arg+1		;

 	TBLRD	*+
 MOVF TABLAT,W,ACCESS		;
 MULWF Reminder+0,BANKED	;
 MOVFF PRODH,A_Arg+2		;

 MULWF Reminder+1,BANKED	;
 MOVF  PRODL,W,ACCESS		;
 ADDWF A_Arg+2,F,BANKED		;
 MOVF  PRODH,W,ACCESS		;
 ADDWFC	A_Arg+1,F,BANKED	;
 CLRF  WREG,ACCESS			;
 ADDWFC A_Arg+0,F,BANKED	;

 	TBLRD	*-
 MOVF  TABLAT,W,ACCESS		;
 MULWF Reminder+0,BANKED	;
 MOVF  PRODL,W,ACCESS		;
 ADDWF A_Arg+2,F,BANKED		;
 MOVF  PRODH,W,ACCESS		;
 ADDWFC	A_Arg+1,F,BANKED	;
 CLRF  WREG,ACCESS			;
 ADDWFC	A_Arg+0,F,BANKED	;
		
 MOVF  B_Arg+0,W,BANKED		;
 MULWF A_Arg+1,BANKED		;
 MOVFF PRODL,A_Arg+3		;
 MOVFF PRODH,A_Arg+2		;
 MULWF A_Arg+0,BANKED		;
 MOVF  PRODL,W,ACCESS		;
 ADDWF A_Arg+2,F,BANKED		;

 MOVF  A_Arg+3,W,BANKED		; estimate remainder
 SUBWF Reminder+0,F,BANKED	;
 MOVF  A_Arg+2,W,BANKED		;
 SUBWFB	Reminder+1,F,BANKED	;

 BTFSS Reminder+1,MSB,BANKED; test remainder
 					retlw	0x0

 DECF   A_Arg+1,F,BANKED	;
 CLRF   WREG,ACCESS			;
 SUBWFB A_Arg+0,F,BANKED	;

 MOVF   B_Arg+0,W,BANKED	;
 ADDWF  Reminder+0,F,BANKED	;
 					retlw	0x0
